class CloseCashierPdf < Prawn::Document
  include ActionView::Helpers::NumberHelper
  attr_accessor :label_width,:price_column_width,:page_width, :page_height, :margin, :price_width, :item_width, :header_font_size, :item_font_size,:item_height,:qty_width,:total_width,:item_description_width,:text_width

  def initialize(printer_settings, shift_sale,shop_details,sale_taxes,other_payment,total_amount_by_account,total_discount_by_account,total_member_discount,total_waste,total_spoile)
    self.page_width = printer_settings.page_width  #PrintSetting.where("name = ?","Close Cashier").first.page_width
    self.page_height = printer_settings.page_height
    self.header_font_size = printer_settings.header_font_size.to_i
    self.item_font_size = printer_settings.item_font_size.to_i
    self.margin = 5
    self.price_width = 60
    self.qty_width = 20
    self.total_width = 40
    self.item_width = self.page_width - ((self.price_width + self.qty_width + self.total_width))
    self.item_height = 15
    self.item_description_width = (self.page_width-20) / 2
    self.label_width = 100

    self.text_width = (self.page_width - 80) - self.price_width / 3
    # @item_width = self.page_width.to_i / 2
    # @qty_width = @item_width.to_i / 3
    # @double = @qty_width * 1.3
    # @half_qty = @qty_width / 2
    #setting page margin and width
    super(:margin => [printer_settings.heading_space, self.margin, self.margin, self.margin], :page_size => [self.page_width, self.page_height])

    # db font setup
    if printer_settings.font != ""
        font_families.update("#{printer_settings.font}" => {
            :normal => "public/fonts/#{printer_settings.font}.ttf",
            :italic => "public/fonts/#{printer_settings.font}.ttf",
            :bold => "public/fonts/#{printer_settings.font}.ttf",
            :bold_italic => "public/fonts/#{printer_settings.font}.ttf"
        })

        font "#{printer_settings.font}"
        fallback_fonts ["Courier", "Helvetica", "Times-Roman"]
    end
    # font "public/fonts/Zawgyi-One.ttf"
    # font "public/fonts/padauk.ttf"

    #precision checked
    if printer_settings.precision.to_i > 2
        printer_settings.precision = 2
    end
    #check delimiter
    if printer_settings.delimiter
        delimiter = ","
    else
        delimiter = ""
    end

    header( shop_details)

    stroke_horizontal_rule

    shift_detail(shift_sale,sale_taxes,other_payment,total_amount_by_account,total_discount_by_account,total_member_discount,printer_settings.precision,delimiter,total_waste,total_spoile) 
  end

  def header (shop_details)
    move_down 7
    text "#{shop_details.name}", :left_margin => -10, :size => self.header_font_size,:align => :center
    move_down 5
    text "#{shop_details.address}", :size => self.item_font_size,:align => :center
    # move_down self.item_height
    move_down 5
    text "#{shop_details.phone_no}", :size => self.item_font_size,:align => :center
    move_down 5

    stroke_horizontal_rule
  end

  def shift_detail(shift_sale,sale_taxes,other_payment,total_amount_by_account,total_discount_by_account,total_member_discount,precision,delimiter,total_waste,total_spoile)
        move_down 7
         y_position = cursor
        bounding_box([0,y_position], :width =>self.label_width, :height => self.item_height) do
            text "Cashier : ", :size => self.item_font_size,:align => :left
        end
        bounding_box([self.label_width,y_position], :width => self.label_width, :height => self.item_height) do
            text "#{ shift_sale.employee.name}" , :size => self.item_font_size,:align => :left
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.label_width, :height => self.item_height) do
            text "Cashier Station : ", :size => self.item_font_size,:align => :left
        end
        bounding_box([self.label_width,y_position], :width => self.label_width, :height => self.item_height) do
            text "#{ shift_sale.cashier_terminal.name}" , :size => self.item_font_size,:align => :left
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.label_width, :height => self.item_height) do
            text "Opening Date : ", :size => self.item_font_size,:align => :left
        end
        bounding_box([self.label_width,y_position], :width => self.label_width, :height => self.item_height) do
            text "#{ shift_sale.shift_started_at.utc.getlocal.strftime('%d-%m-%Y %I:%M %p') }" , :size => self.item_font_size,:align => :left
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.label_width, :height => self.item_height) do
            text "Closing Date : ", :size => self.item_font_size,:align => :left
        end
        bounding_box([self.label_width,y_position], :width => self.label_width, :height => self.item_height) do
            text "#{ shift_sale.shift_closed_at.utc.getlocal.strftime('%d-%m-%Y %I:%M %p') }" , :size => self.item_font_size,:align => :left
        end
        
        y_position = cursor
        bounding_box([0,y_position], :width =>self.label_width, :height => self.item_height) do
            text "Opening Float : ", :size => self.item_font_size,:align => :left
        end
        bounding_box([self.label_width,y_position], :width => self.label_width, :height => self.item_height) do
            text "#{ number_with_precision(shift_sale.opening_balance, :precision => precision.to_i, :delimiter => delimiter)}" , :size => self.item_font_size,:align => :left
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.label_width, :height => self.item_height) do
            text "Closing Float : ", :size => self.item_font_size,:align => :left
        end
        bounding_box([self.label_width,y_position], :width => self.label_width, :height => self.item_height) do
            text "#{ number_with_precision(shift_sale.closing_balance, :precision => precision.to_i, :delimiter => delimiter)}" , :size => self.item_font_size,:align => :left
            # text_box  "#{number_with_precision(total_price, :precision => precision.to_i, :delimiter => delimiter)}"
        end


        move_down 10

        y_position = cursor
        bounding_box([0,y_position], :width =>self.page_width - 10, :height => 20) do
         text "Shift Sale Summary", :size => self.header_font_size, :align => :center
        end
        move_down 10

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Received Amount :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{number_with_precision(shift_sale.closing_balance, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right

        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Cash In:", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{number_with_precision(shift_sale.cash_in, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Cash Out:", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{number_with_precision(shift_sale.cash_out, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
        end

        move_down -5
        stroke_horizontal_rule
        move_down 7

        @total_foc = 0
        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Cash Payment :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{ number_with_precision(shift_sale.cash_sales, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Credit Payment :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{number_with_precision(shift_sale.credit_sales, :precision => precision.to_i, :delimiter => delimiter) }", :size => self.item_font_size, :align => :right
        end
        #start other payment details 
        if shift_sale.other_sales > 0
            other_payment.each do |other|
              @total_foc = other.foc_amount.round(2)
              if other.mpu_amount && other.mpu_amount.to_f > 0
                y_position = cursor
                bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
                 text "MPU Payment :", :size => self.item_font_size, :align => :right
                end
                bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
                 text "#{ number_with_precision(other.mpu_amount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
                end
              end

              if other.visa_amount && other.visa_amount.to_f > 0
                y_position = cursor
                bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
                 text "VISA Payment :", :size => self.item_font_size, :align => :right
                end
                bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
                 text "#{number_with_precision(other.visa_amount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
                end
              end

              if other.master_amount && other.master_amount.to_f > 0
                y_position = cursor
                bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
                 text "Master Payment :", :size => self.item_font_size, :align => :right
                end
                bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
                 text "#{ number_with_precision(other.master_amount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
                end
              end

              if other.jcb_amount && other.jcb_amount.to_f > 0
                y_position = cursor
                bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
                 text "JCB Payment :", :size => self.item_font_size, :align => :right
                end
                bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
                 text "#{ number_with_precision(other.jcb_amount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
                end
              end

              if other.unionpay_amount && other.unionpay_amount.to_f > 0
                y_position = cursor
                bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
                 text "UNIONPAY Payment :", :size => self.item_font_size, :align => :right
                end
                bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
                 text "#{ number_with_precision(other.unionpay_amount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
                end
              end

              if other.alipay_amount && other.alipay_amount.to_f > 0
                y_position = cursor
                bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
                 text "Alipay Payment :", :size => self.item_font_size, :align => :right
                end
                bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
                 text "#{ number_with_precision(other.alipay_amount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
                end
              end

              if other.junctionpay_amount && other.junctionpay_amount.to_f > 0
                y_position = cursor
                bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
                 text "JunctionPay Payment :", :size => self.item_font_size, :align => :right
                end
                bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
                 text "#{ number_with_precision(other.junctionpay_amount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
                end
              end

              if other.dinga_amount && other.dinga_amount.to_f > 0
                y_position = cursor
                bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
                 text "Dinga Payment :", :size => self.item_font_size, :align => :right
                end
                bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
                 text "#{ number_with_precision(other.dinga_amount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
                end
              end

              if other.paypar_amount && other.paypar_amount.to_f > 0
                y_position = cursor
                bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
                 text "Redeem Payment :", :size => self.item_font_size, :align => :right
                end
                bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
                 text "#{ number_with_precision(other.paypar_amount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
                end
              end

              if other.paymal_amount && other.paymal_amount.to_f > 0
                y_position = cursor
                bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
                 text "Paymal Payment :", :size => self.item_font_size, :align => :right
                end
                bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
                 text "#{ number_with_precision(other.paymal_amount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
                end
              end

              if other.giftvoucher_amount && other.giftvoucher_amount.to_f > 0
                y_position = cursor
                bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
                 text "GiftVoucher Payment :", :size => self.item_font_size, :align => :right
                end
                bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
                 text "#{ number_with_precision(other.giftvoucher_amount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
                end
              end
            end
        else
            y_position = cursor
            bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
             text "Other Payment :", :size => self.item_font_size, :align => :right
            end
            bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
             text "#{ number_with_precision(shift_sale.other_sales, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
            end
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Rounding Adjustments :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{ number_with_precision(shift_sale.total_rounding, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Total :", :style => :bold, :size => self.header_font_size - 1, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{ number_with_precision(shift_sale.grand_total, :precision => precision.to_i, :delimiter => delimiter)}", :style => :bold, :size => self.header_font_size - 1, :align => :right
        end

        # end other payment details 
        move_down -5
        stroke_horizontal_rule
        move_down 7

        #start service charges and commercial tax
        sale_taxes.each do |tax|
          y_position = cursor
          bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
           text "#{tax.tax_name} :", :size => self.item_font_size, :align => :right
          end
          bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
           text "#{ number_with_precision(tax.st_amount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
          end
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Total Taxes :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{ number_with_precision(shift_sale.total_taxes, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Net Sales :", :style => :bold, :size => self.header_font_size - 1, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{number_with_precision(shift_sale.nett_sales, :precision => precision.to_i, :delimiter => delimiter) }", :style => :bold , :size => self.header_font_size - 1, :align => :right
        end
        #end for service charges and commercial tax
#COMMENTED FOR NO NEED AND NOT CORRECT WHEN OTHER CHARGES
        # y_position = cursor
        # bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
        #  text "Total Sale :", :size => self.item_font_size, :align => :right
        # end
        # bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
        #  text "#{shift_sale.total_revenue}", :size => self.item_font_size, :align => :right
        # end

        move_down -5
        stroke_horizontal_rule
        move_down 7
        #start total amount by Account Like Food / Beverage /..
        total_discount_by_account.each do |amount|
        
          y_position = cursor
          bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
           text "Total #{amount.account_name} Discount:", :size => self.item_font_size, :align => :right
          end
          bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
           text "#{ number_with_precision(amount.total_price, :precision => precision.to_i, :delimiter => delimiter)} ", :size => self.item_font_size, :align => :right
          end
        end
        #end total amount by Account 

        if total_member_discount[0].member_discount.present?
          @member_discount = total_member_discount[0].member_discount rescue 0.0 
          @overall = shift_sale.total_discounts - @member_discount
                
            y_position = cursor
            bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
             text "Total Member Discount :", :size => self.item_font_size, :align => :right
            end
            bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
             text "#{ number_with_precision(@member_discount, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
            end
        else 
          @overall = shift_sale.total_discounts                   
        end
        
        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Total Discount :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{ number_with_precision(@overall, :precision => precision.to_i, :delimiter => delimiter)}", :size => self.item_font_size, :align => :right
        end 

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Total FOC :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "(#{ number_with_precision(@total_foc, :precision => precision.to_i, :delimiter => delimiter)})", :size => self.item_font_size, :align => :right
        end     

        y_position = cursor 
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Total Void :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "(#{shift_sale.total_void})", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Total Waste :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "(#{ number_with_precision(total_waste, :precision => precision.to_i, :delimiter => delimiter)})", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Total Spoile :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "(#{ number_with_precision(total_spoile, :precision => precision.to_i, :delimiter => delimiter)})", :size => self.item_font_size, :align => :right
        end

        # y_position = cursor
        # bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
        #  text "Grand Total :", :size => self.item_font_size, :align => :right
        # end
        # bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
        #  text "#{shift_sale.grand_total}", :size => self.item_font_size, :align => :right
        # end
        
        move_down -5
        stroke_horizontal_rule
        move_down 7

        #start total amount by Account Like Food / Beverage /..
        total_amount_by_account.each do |amount|        
          y_position = cursor
          bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
           text "Total #{amount.account_name} Amount :", :size => self.item_font_size, :align => :right
          end
          bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
           text "#{number_with_precision(amount.total_price, :precision => precision.to_i, :delimiter => delimiter)} ", :size => self.item_font_size, :align => :right
          end
        end
        #end total amount by Account 

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Total Dine-in Count :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.dining_count}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Total Takeaway Count :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.takeaway_count}", :size => self.item_font_size, :align => :right
        end

        y_position = cursor
        bounding_box([0,y_position], :width =>self.item_description_width, :height => 20) do
         text "Total Receipts :", :size => self.item_font_size, :align => :right
        end
        bounding_box([self.item_description_width,y_position], :width =>self.price_width, :height => 20) do
         text "#{shift_sale.total_receipt}", :size => self.item_font_size, :align => :right
        end

        move_down 5
        stroke_horizontal_rule
        move_down 5
    move_down 5
  end
end